#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.

#
# addOGOrbInitializers
#
from java.lang import System

def findOrbInitializerByName(initializerName, interceptors):
    for interceptor in interceptors:
        name=AdminConfig.showAttribute(interceptor,"name")
        if (name == initializerName):
            return interceptor
    return ""

def updateOrbInitializers(orb, isAppServer):
    interceptors = AdminConfig.showAttribute(orb, "interceptors").replace("[","").replace("]","")
    if interceptors <> "":
        interceptors = interceptors.split(" ")

        if (findOrbInitializerByName("com.ibm.ws.objectgrid.corba.ObjectGridInitializer", interceptors) == ""):
            attributes = [ ["name", "com.ibm.ws.objectgrid.corba.ObjectGridInitializer"] ]
            AdminConfig.create("Interceptor", orb, attributes)
            AdminConfig.save()
        else:
            print "ObjectGrid ServerInitializer already exists"

    return


def addOGOrbInitializers():
    servers = AdminConfig.list("Server")
    if (servers <> ""):

        if System.getProperty("os.name").startswith("Windows"):
            servers = servers.split("\r\n")
        else:
            servers = servers.split("\n")

        for server in servers:
            serverType = AdminConfig.showAttribute(server, "serverType")
            isAppServer = "false"
            skip = "true"
            if (serverType == "DEPLOYMENT_MANAGER" or serverType == "NODE_AGENT"):
                skip = "false"
            if (serverType == "APPLICATION_SERVER"):
                skip = "false"
                isAppServer = "true"
            if (skip == "false"):
                orbs = AdminConfig.list("ObjectRequestBroker", server)
                if (orbs <> ""):
                    if System.getProperty("os.name").startswith("Windows"):
                        orbs = orbs.split("\r\n")
                    else:
                        orbs = orbs.split("\n")
                    for orb in orbs:
                        print "updating " + orb
                        updateOrbInitializers(orb, isAppServer)

    print "Updating server templates"
    templates = AdminConfig.listTemplates("ObjectRequestBroker", "APPLICATION_SERVER")
    if (templates <> ""):
       if System.getProperty("os.name").startswith("Windows"):
           templates = templates.split("\r\n")
       else:
           templates = templates.split("\n")
       for template in templates:
           print "updating " + template
           updateOrbInitializers(template, "true")

    print "AdminConfig.save()"
    AdminConfig.save()
    print "finished."
    return

#
#  main() -
#

print "*********************************"
print "Add ObjectGrid Orb Initializers          "
print "*********************************"
addOGOrbInitializers()
