#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.

#
# addOGPMIModules
#
from java.lang import System

def findPMIModuleByName(pmiModuleName, pmiModules):
    for pmiModule in pmiModules:
        name=AdminConfig.showAttribute(pmiModule,"moduleName")
        if (name == pmiModuleName):
            return pmiModule
    return ""

def updatePMIModules(serverPMIModule):
    pmiModules = AdminConfig.showAttribute(serverPMIModule, "pmimodules").replace("[","").replace("]","")
    if pmiModules <> "":
        pmiModules = pmiModules.split(" ")

        if (findPMIModuleByName("objectGridModule", pmiModules) == ""):
            attributes1 = [ ["moduleName", "objectGridModule"],
                            ["type", "com.ibm.ws.objectgrid.pmi.objectGridModule"],
                            ["enable", ""],
                            ["pmimodules", [] ] ]
            AdminConfig.create("PMIModule", serverPMIModule, attributes1)
        else:
            print "objectGridModule PMIModule already exists"

        if (findPMIModuleByName("mapModule", pmiModules) == ""):
            attributes1 = [ ["moduleName", "mapModule"],
                            ["type", "com.ibm.ws.objectgrid.pmi.mapModule"],
                            ["enable", ""],
                            ["pmimodules", [] ] ]
            AdminConfig.create("PMIModule", serverPMIModule, attributes1)
        else:
            print "mapModule PMIModule already exists"

        if (findPMIModuleByName("agentModule", pmiModules) == ""):
            attributes1 = [ ["moduleName", "agentModule"],
                            ["type", "com.ibm.ws.objectgrid.pmi.agentModule"],
                            ["enable", ""],
                            ["pmimodules", [] ] ]
            AdminConfig.create("PMIModule", serverPMIModule, attributes1)
        else:
            print "agentManagerModule PMIModule already exists"

        if (findPMIModuleByName("queryModule", pmiModules) == ""):
            attributes1 = [ ["moduleName", "queryModule"],
                            ["type", "com.ibm.ws.objectgrid.pmi.queryModule"],
                            ["enable", ""],
                            ["pmimodules", [] ] ]
            AdminConfig.create("PMIModule", serverPMIModule, attributes1)
        else:
            print "queryModule PMIModule already exists"

        if (findPMIModuleByName("hashIndexModule", pmiModules) == ""):
            attributes1 = [ ["moduleName", "hashIndexModule"],
                            ["type", "com.ibm.ws.objectgrid.pmi.hashIndexModule"],
                            ["enable", ""],
                            ["pmimodules", [] ] ]
            AdminConfig.create("PMIModule", serverPMIModule, attributes1)
        else:
            print "hashIndexModule PMIModule already exists"
	
	AdminConfig.save()
    return


def addOGPMIModules():
    servers = AdminConfig.list("Server")
    if (servers <> ""):

        if System.getProperty("os.name").startswith("Windows"):
            servers = servers.split("\r\n")
        else:
            servers = servers.split("\n")

        for server in servers:
            serverType = AdminConfig.showAttribute(server, "serverType")
            if (serverType == "APPLICATION_SERVER"):
                pmiModules = AdminConfig.list("PMIModule", server)
                if (pmiModules <> ""):
                    if System.getProperty("os.name").startswith("Windows"):
                        pmiModules = pmiModules.split("\r\n")
                    else:
                        pmiModules = pmiModules.split("\n")
                    for pmiModule in pmiModules:
                        name = AdminConfig.showAttribute(pmiModule, "moduleName")
                        if (name == "pmi"):
                            print "updating " + pmiModule
                            updatePMIModules(pmiModule)
    print "Updating server templates"
    templates = AdminConfig.listTemplates("PMIModule", "APPLICATION_SERVER")
    if (templates <> ""):
       if System.getProperty("os.name").startswith("Windows"):
           templates = templates.split("\r\n")
       else:
           templates = templates.split("\n")
       for template in templates:
           name = AdminConfig.showAttribute(template, "moduleName")
           if (name == "pmi"):
               print "updating " + template
               updatePMIModules(template)

    print "AdminConfig.save()"
    AdminConfig.save()
    print "finished."
    return

#
#  main() -
#

print "*********************************"
print "Add ObjectGrid PMI Modules               "
print "*********************************"
addOGPMIModules()
