#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.

#
# removeOGOrbInitializers
#
from java.lang import System
from jarray import array

def removeOrbInitializers(orb, isAppServer):
    count = 0
    interceptors = AdminConfig.showAttribute(orb, "interceptors").replace("[","").replace("]","")
    if interceptors <> "":
        interceptors = interceptors.split(" ")

        for interceptor in interceptors:
            name = AdminConfig.showAttribute(interceptor, "name")
            if (name == "com.ibm.ws.objectgrid.corba.ObjectGridInitializer"):
                count = count + 1
                AdminConfig.remove(interceptor)
                AdminConfig.save()
        if (count < 1 and isAppServer == "true"):
            print "One or more ObjectGrid Orb Interceptors were not found"
        if (count < 1 and isAppServer == "false"):
            print "One or more ObjectGrid Orb Interceptors were not found"
    return

def removeOGOrbInitializers():
    servers = AdminConfig.list("Server")
    if (servers <> ""):

        if System.getProperty("os.name").startswith("Windows"):
            servers = servers.split("\r\n")
        else:
            servers = servers.split("\n")

        for server in servers:
            serverType = AdminConfig.showAttribute(server, "serverType")
            isAppServer = "false"
            skip = "true"
            if (serverType == "DEPLOYMENT_MANAGER" or serverType == "NODE_AGENT"):
                skip = "false"
            if (serverType == "APPLICATION_SERVER"):
                skip = "false"
                isAppServer = "true"
            if (skip == "false"):
                orbs = AdminConfig.list("ObjectRequestBroker", server)
                if (orbs <> ""):
                    if System.getProperty("os.name").startswith("Windows"):
                        orbs = orbs.split("\r\n")
                    else:
                        orbs = orbs.split("\n")
                    for orb in orbs:
                        print "updating " + orb
                        removeOrbInitializers(orb, isAppServer)

    print "Updating server templates"
    templates = AdminConfig.listTemplates("ObjectRequestBroker", "APPLICATION_SERVER")
    if (templates <> ""):
       if System.getProperty("os.name").startswith("Windows"):
           templates = templates.split("\r\n")
       else:
           templates = templates.split("\n")
       for template in templates:
           print "updating " + template
           removeOrbInitializers(template, "true")

    print "AdminConfig.save()"
    AdminConfig.save()
    print "finished."
    return

#
#  main() -
#

print "*********************************"
print "Remove ObjectGrid Orb Initializers       "
print "*********************************"
removeOGOrbInitializers()
