#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.
import sys, java
lineSeparator = java.lang.System.getProperty('line.separator')

#
# Stolen from some other random augmentation script, this makes a list from
# the sort of thing that AdminConfig.list() and so on return.
#
def convertToList(inlist):
     outlist=[]
     if (len(inlist)>0 and inlist[0]=='[' and inlist[len(inlist)-1]==']'):
        inlist = inlist[1:len(inlist)-1]
        clist = inlist.split(" ")
     else:
        clist = inlist.split(lineSeparator)
     for elem in clist:
        elem=elem.rstrip();
        if (len(elem)>0):
           outlist.append(elem)
     return outlist

#
# Removes the endPointNames from the serverEntry. 
#
def removeNamedEndPoints(serverEntry, endPointNames):
    serverName = AdminConfig.showAttribute(serverEntry,"serverName")
    print serverName
    namedEndPoints = convertToList(AdminConfig.list("NamedEndPoint",serverEntry))
    for namedEndPoint in namedEndPoints:
      endPointName = AdminConfig.showAttribute(namedEndPoint,"endPointName")
      if endPointName in endPointNames:
        print "Removing "+endPointName+" from "+serverName
        try:
          AdminConfig.remove(namedEndPoint)
        except:
          print "Exception removing " + endPointName + " from " + serverName
          continue

#
# Removes named endpoints with any of the given names from all serverentries
# on the given node
#
def removeEndPointsFromServerEntries(node,targetNames):
  serverEntries = convertToList(AdminConfig.list("ServerEntry",node))
  for serverEntry in serverEntries:
      print "Processing server"
      removeNamedEndPoints(serverEntry, targetNames);

#
# For each server template a set of end point names are removed from its port
# configuration.
#
def removeEndPointsFromServerTemplate(serverTemplate,endPointNames):
  #serverTemplateName = AdminConfig.showAttribute(serverTemplate,"serverName");
  #if (serverTemplateName != "default"):
  #    return;
  
  #serverType = AdminConfig.showAttribute(serverTemplate,"serverType");
  #print "serverType:",serverType
  #if (serverType != "APPLICATION_SERVER"):
  #    return;
  print "Processing server template"
  removeNamedEndPoints(serverTemplate, endPointNames);



# Do it for all nodes and all serverentries, because why not
PORT_LIST = ["XIO_ADDRESS"]

nodes = convertToList(AdminConfig.list("Node"))
print "--------------Remove XIO ports from existing servers----------------"
for node in nodes:
  nodeName = AdminConfig.showAttribute(node,"name")
  print "Processing node",nodeName          
  removeEndPointsFromServerEntries(node, PORT_LIST)

print "------------------Remove XIO ports from templates-------------------"
serverTemplates = convertToList(AdminConfig.listTemplates("ServerEntry"));
#print "serverTemplates: ", serverTemplates
for serverTemplate in serverTemplates:
    removeEndPointsFromServerTemplate(serverTemplate, PORT_LIST);

print "---------------------Saving XIO port changes------------------------"
AdminConfig.save()